<template>
  <header>
    <nav class="navbar fixed-top">
      <v-btn class="header__navigation" height="70px" width="160px" text to="/home">
        <IconifyIcon :icon="icons.homeFilled" height="40px" width="40px" class="header__navigation__icon"/>
        <span>Gallery</span>
      </v-btn>
      <v-btn class="header__navigation" height="70px" width="160px" text to="/pictures/all">
        <IconifyIcon :icon="icons.pictureFilled" height="41px" width="49px" class="header__navigation__icon"/>
        <span>Pics</span>
      </v-btn>
      <v-btn class="header__navigation" height="70px" width="160px" text to="/people/search">
        <IconifyIcon :icon="icons.peopleFill" height="41px" width="55px" class="header__navigation__icon"/>
        <span>People</span>
      </v-btn>
      <template v-if="!isAuthed">
        <v-btn class="header__sign-up" width="110px" color="#C8C8C8">
          <router-link tag="a" to="/sign-up">Sign Up</router-link>
        </v-btn>
        <router-link to="/sign-in" class="header__sign-in">Sign In</router-link>
      </template>
      <v-app v-else class="header__drop-down">
        <v-menu offset-y>
          <template v-slot:activator="{ on, attrs }">
            <v-btn
              color="primary"
              v-bind="attrs"
              v-on="on"
              icon>
              <v-avatar rounded="true" class="header__avatar" size="60px">
                <img
                  :src="userAvatar"
                  alt="Avatar"
                />
              </v-avatar>
            </v-btn>
          </template>
          <v-list>
            <v-list-item>
              <IconifyIcon
                class="header__drop-down__item-icon"
                :icon="icons.profileIcon"
                :style="{color: 'rgba(89, 89, 89, 0.9)'}"
                width="23px"
                height="23px"
              />
              <v-btn text class="header__drop-down__item" to="/profile">
                Profile
              </v-btn>
            </v-list-item>
            <v-divider style="margin-top: 5px"/>
            <v-list-item>
              <IconifyIcon class="header__drop-down__item-icon" :icon="icons.logoutIcon" :style="{color: '#333333'}" />
              <v-btn
                @click="logOut"
                text
                class="header__drop-down__item">
                Log Out
              </v-btn>
            </v-list-item>
          </v-list>
        </v-menu>
      </v-app>
    </nav>
  </header>
</template>

<!--suppress JSValidateTypes -->
<script>
import IconifyIcon from '@iconify/vue'
import homeFilled from '@iconify/icons-ant-design/home-filled'
import pictureFilled from '@iconify/icons-ant-design/picture-filled'
import peopleFill from '@iconify/icons-bi/people-fill'
import logoutIcon from '@iconify/icons-simple-line-icons/logout'
import profileIcon from '@iconify/icons-gg/profile'
import { mapGetters, mapMutations } from 'vuex'
import { LogOut } from '@/api/auth'

export default {
  components: {
    IconifyIcon
  },

  computed: {
    ...mapGetters([
      'isAuthed',
      'userAvatar'
    ])
  },

  methods: {
    ...mapMutations([
      'resetState'
    ]),

    async logOut() {
      const status = await LogOut()
      if (!status) {
        return
      }

      if (status === 200) {
        this.resetState()
      } else {
        this.$toasted.error('Oh no... Something bad happened')
      }
    }
  },

  data() {
    return {
      icons: {
        homeFilled,
        pictureFilled,
        peopleFill,
        logoutIcon,
        profileIcon
      }
    }
  }
}
</script>

<style>
header {
  height: 70px;
  border: 1px solid rgba(44, 44, 44, 0.2);
  box-shadow: 0 1px 2px rgba(0, 0, 0, 0.25);
}

.header__navigation {
  margin-top: -2px;
  font-family: Roboto, fantasy;
  font-style: normal;
  font-weight: normal;
  font-size: 26px;
  padding: 0;
  border: none;
  background: none;
}

.header__sign-up {
  margin-top: 18px;
  margin-right: 15px;
  float: right;
  font-family: Roboto, fantasy;
  font-style: normal;
  font-weight: 900;
  font-size: 20px !important;
  border-radius: 8px !important;
}

.header__sign-in {
  margin-top: 23px;
  margin-right: 15px;
  float: right;
  font-family: Roboto, fantasy;
  font-style: normal;
  font-weight: normal;
  font-size: 24px;
}

.header__avatar {
  border-style: groove;
  border-width: thin;
  border-color: rgba(51, 51, 51, 0.6);
}

nav span, nav a {
  text-decoration: none;
  color: rgba(51, 51, 51, 0.8);
}

.header__navigation__icon {
  color: rgba(51, 51, 51, 0.8);
}

.header__drop-down {
  float: right;
}

.v-application--wrap {
  margin-top: 15px;
  margin-right: 15px;
  height: 0 !important;
  min-height: 0 !important;
}

.header__drop-down__item {
  margin-top: 5px;
}

.header__drop-down__item-icon {
  margin-top: 5px;
  margin-left: 5px;
  position: absolute;
}

.header__drop-down__item .v-btn__content {
  margin-left: 14px;
}

</style>
